import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;

/**	A Cluster will contain an image file (jpg) and a text file
*	listing each galaxy in the cluster along with its pixel coordinates
*	and properties.
**/


public class Cluster {

	public String name;

	public Dimension imageSize;

	public Image image;

	String dataCredit, imageCredit;

	public Point center;

	public Vector galList = new Vector(10,1);

	int xOrigin, yOrigin;
	double ppasX, ppasY;

	/**
	*	Returns a new Cluster of the specified name.
	*	The name will be used to retrieve the text
	*	and image file for this cluster, which should
	*	be named "name.db" and "name.jpg" respectively.
	**/

	public Cluster(String s) {
		this.name= new String(s);
		getGalaxies();
		setImage();
	}

	/**
	*	Retrieve the name of this cluster
	**/

	public String getName() {
		return(this.name);
	}

	public void setImage() {
		try {
			image = Toolkit.getDefaultToolkit().getImage(new URL(Applet3.codebase + "data/" + this.name + ".jpg"));
		} catch(Exception e) {
			System.out.println("error opening image file:");
			System.out.println(e);
		}
	}

	public Image getImage() {
		return(image);
	}



	public double[] getVelArray() {
		int checkCount=0, index = 0;
		for(int i=0; i< galList.size(); i++) {
			if (((Galaxy)galList.elementAt(i)).isChecked()) {
				checkCount++;
			}
		}
		double[] returnArray = new double[checkCount];
		for(int i=0; i< galList.size(); i++) {
			if (((Galaxy)galList.elementAt(i)).isChecked()) {
				returnArray[index] = ((Galaxy)galList.elementAt(i)).vel;
				index++;
			}
		}
		return(returnArray);
	}

	public void getGalaxies() {
		String pointX, pointY, number, galname, vel, mag, radius;
		StringTokenizer st;
		String lineOfText;

		// ILL HAVE TO USE A URL CONNECTION - THIS IS BARFING OUT CURRENTLY
		// http://www.devdaily.com/java/edu/pj/pj010023/



  		try {
			URL url = new URL(Applet3.codebase + "/data/" + name + ".db");
			URLConnection urlConn;
			DataInputStream dis;

			// Note:  a more portable URL:
			//url = new URL(getCodeBase().toString() + "/ToDoList/ToDoList.txt");

			urlConn = url.openConnection();
			urlConn.setDoInput(true);
			urlConn.setUseCaches(false);

			dis = new DataInputStream(urlConn.getInputStream());


			BufferedReader reader = new BufferedReader(new InputStreamReader(dis));
			while((lineOfText = reader.readLine()) != null) {
				if(lineOfText.indexOf("!") == 0) {
					st = new StringTokenizer(lineOfText,"!");
					imageSize = new Dimension(Integer.parseInt(st.nextToken().trim()),Integer.parseInt(st.nextToken().trim()));
					//System.out.println(imageSize);
				}
				else if(lineOfText.indexOf("#") == 0) {
					st = new StringTokenizer(lineOfText,"#");
					Applet3.histogram.xMin = Double.valueOf(st.nextToken().trim()).doubleValue();
					Applet3.histogram.xMax = Double.valueOf(st.nextToken().trim()).doubleValue();
					Applet3.histogram.calcMin = Applet3.histogram.xMin;
					Applet3.histogram.calcMax = Applet3.histogram.xMax;
					CalculationPanel.calcMinInputField.setText(Applet3.histogram.calcMin+"");
					CalculationPanel.calcMaxInputField.setText(Applet3.histogram.calcMax+"");
					//System.out.println(imageSize);
				}
				else if(lineOfText.indexOf("$") == 0) {
					st = new StringTokenizer(lineOfText,"$");
					dataCredit = st.nextToken().trim();
					imageCredit = st.nextToken().trim();
					//System.out.println(imageSize);
				}
				else if(lineOfText.indexOf("|")!=-1) {
					st = new StringTokenizer(lineOfText,"|");
					number = st.nextToken().trim();
					galname = st.nextToken().trim();
					pointX = st.nextToken().trim();
					pointY = st.nextToken().trim();
					mag = st.nextToken().trim();
					vel = st.nextToken().trim();
					radius = st.nextToken().trim();
					galList.addElement(new Galaxy(number,galname,Integer.parseInt(pointX),Integer.parseInt(pointY),Double.valueOf(mag).doubleValue(),Double.valueOf(vel).doubleValue(),Double.valueOf(radius).doubleValue()));
				}
			}
			dis.close();
		} catch (Exception e) {
			System.out.println(e);
		}

	}


}
