import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

public class ClusterMaker extends Frame {

	static File inputFile, outputFile;
	String imageName;

	static BufferedReader reader;
	static PrintWriter writer;
	static ImageHolder imageHolder;

	boolean waitingForMouse = true;

	int imageWidth, imageHeight;




	static Vector gals = new Vector(0,5);

	int xCenter, yCenter;
	double pparcsecY, pparcsecX;
	double angle=0, anglerad=0;


	public static void main(String[] args) {
		if(args.length != 3) {
			System.out.println("Usage: java ClusterMaker inputFile outputFile imagefile");
			System.exit(0);
		}
		ClusterMaker me = new ClusterMaker(args[0], args[1], args[2]);
	}

	public ClusterMaker(String in, String out, String name) {
		imageHolder = new ImageHolder(name);

		setBounds(50,50,500,500);

		this.imageName = name;

		setTitle("Cluster Maker");
		show();

		setLayout(null);
		add(imageHolder);
		imageHolder.setBounds(0,0,500,500);


		try {
			inputFile = new File(in);
			outputFile = new File(out);
			System.out.print("Attempting parse...");
			parse(inputFile, outputFile);
			System.out.println("Success!");
			System.out.println(gals.size() + " galaxies found");
		} catch (FileNotFoundException FNFe) {
			System.out.println(FNFe);
		} catch (IOException IOe) {
			System.out.println(IOe);
		}

		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

		findCenter();
		setLocations();


			addKeyListener(new KeyAdapter() {
				public void keyPressed(KeyEvent e) {
					//System.out.println(e);
					double multiplier=1;
					boolean update = true;


					if(e.getKeyChar()=='.') {
						if(e.isControlDown()) multiplier = 10;
						angle+=.01 * multiplier;
						anglerad=angle*Math.PI/180;
						System.out.println("angle: " + angle);
					}
					else if(e.getKeyChar()==',') {
						if(e.isControlDown()) multiplier = 10;
						angle-=.01 * multiplier;
						anglerad=angle*Math.PI/180;
						System.out.println("angle: " + angle);
					}


					else if(e.getKeyChar()=='x') {
						if(e.isControlDown()) multiplier = 10;
						pparcsecX+=.001*pparcsecX * multiplier;
						System.out.println("pparcsecX: " + pparcsecX);
					}
					else if(e.getKeyChar()=='z') {
						if(e.isControlDown()) multiplier = 10;
						pparcsecX-=.001*pparcsecX * multiplier;
						System.out.println("pparcsecX: " + pparcsecX);
					}

					else if(e.getKeyChar()=='s') {
						if(e.isControlDown()) multiplier = 10;
						pparcsecY+=.001*pparcsecY * multiplier;
						System.out.println("pparcsecY: " + pparcsecY);
					}
					else if(e.getKeyChar()=='a') {
						if(e.isControlDown()) multiplier = 10;
						pparcsecY-=.001*pparcsecY * multiplier;
						System.out.println("pparcsecY: " + pparcsecY);
					}

					else if(e.getKeyChar()=='2') {
						if(e.isControlDown()) multiplier = 10;
						xCenter +=1 * multiplier;
						System.out.println("xCenter: " + xCenter);
					}
					else if(e.getKeyChar()=='1') {
						if(e.isControlDown()) multiplier = 10;
						xCenter -=1 * multiplier;
						System.out.println("xCenter: " + xCenter);
					}

					else if(e.getKeyChar()=='5') {
						if(e.isControlDown()) multiplier = 10;
						yCenter +=1 * multiplier;
						System.out.println("yCenter: " + yCenter);
					}
					else if(e.getKeyChar()=='4') {
						if(e.isControlDown()) multiplier = 10;
						yCenter -=1 * multiplier;
						System.out.println("yCenter: " + yCenter);
					}
					else if(e.getKeyChar()=='w') {
						writeFile();
					}
					else if(e.getKeyChar()=='?') {
						System.out.println("Commands: ");
						System.out.println(", - Decrease Rotation     . - Increase Rotation");
						System.out.println("z - Decrease XStretch     x - Increase XStretch");
						System.out.println("a - Decrease YStretch     s - Increase YStretch");
						System.out.println("1 - Decrease XCenter      2 - Increase XCenter");
						System.out.println("4 - Decrease YCenter      5 - Increase YCenter");
						System.out.println("Holding down control will set increment to 10x its normal value");
						System.out.println("w - Write current positions to output file");
					}
					else {
						update = false;
					}

					if(update == true) {
						setLocations();
						imageHolder.repaint();
					}

				}
			});

	}



	public static void parse(File inputFile,File outputFile) throws IOException {
		reader = new BufferedReader(new FileReader(inputFile));


		String lineOfText, number, name, skyX, skyY, mag, vel;
		StringTokenizer st;
		int lineNumber = 0;

		System.out.println("Parsing Input File");

		while((lineOfText=reader.readLine()) != null) {
			if((lineOfText.indexOf("|")!= -1)&&(lineOfText.indexOf("#") != 0)) {
				st = new StringTokenizer(lineOfText,"|");
				number = st.nextToken().trim();
				//System.out.println("reading in # " + number);
				if(number.length() <= 0) {
					number = "----";
					continue;
				}
				name = st.nextToken().trim();
				if(name.length() <= 0) {
					name = "----";
				}
				skyX = st.nextToken().trim();
				if(skyX.length() <= 0) {
					skyX = "----";
					continue;
				}
				skyY = st.nextToken().trim();
				if(skyY.length() <= 0) {
					skyY = "----";
					continue;
				}
				mag = st.nextToken().trim();
				if(mag.length() <= 0) {
					mag = "----";
					continue;
				}
				vel = st.nextToken().trim();
				if(vel.length() <= 0) {
					vel = "----";
					continue;
				}

				System.out.println(number + "  |  " + name + "  |  " + skyX + "  |  " + skyY + "  |  " + mag + "  |  " + vel);

				//String div = new String("  |  ");




				gals.add(new Galaxy(number,name,Integer.parseInt(skyX),Integer.parseInt(skyY),Double.parseDouble(mag),Double.parseDouble(vel),0));
				//System.out.println(gals.size());
			}
			lineNumber++;
		}

	}

	public void findCenter() {

		int gal1x, gal1y, gal2x, gal2y;
		Galaxy gal1= new Galaxy(), gal2= new Galaxy(), tempGal;


		try {
			String inputLine;
			BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

			System.out.println("What is the width of the image in pixels?");
			imageWidth = Integer.parseInt(in.readLine().trim());

			System.out.println("What is the height of the image in pixels?");
			imageHeight = Integer.parseInt(in.readLine().trim());

			imageHolder.setSize(imageWidth,imageHeight);


			/** Get the screen coodinates of the first galaxy **/

			System.out.println("Enter a galaxy number");
			inputLine = in.readLine().trim();
			for(int i=0; i< gals.size(); i++) {
				gal1 = (Galaxy)gals.elementAt(i);
				if( gal1.number.equals(inputLine)) {
					System.out.println("Found that galaxy at " + i);
					break;
				} else if (i == gals.size()-1) {
					System.out.println("No such galaxy found");
					return;
				}
			}



			System.out.println("Click the image at the center of galaxy " + inputLine);
			waitingForMouse = true;
			while(waitingForMouse) {
				Thread.sleep(50);
				// wait for mouse press
			}
			gal1x = imageHolder.mouseX;
			gal1y = imageHolder.mouseY;
			System.out.println(imageHolder.mouseX + "  " + imageHolder.mouseY);


			/** Get the screen coodinates of the second galaxy **/

			System.out.println("Enter a galaxy number");
			inputLine = in.readLine().trim();
			for(int i=0; i< gals.size(); i++) {
				gal2 = (Galaxy)gals.elementAt(i);
				if( gal2.number.equals(inputLine)) {
					System.out.println("Found that galaxy at " + i);
					break;
				} else if (i == gals.size()-1) {
					System.out.println("No such galaxy found");
					return;
				}
			}

			System.out.println("Click the image at the center of galaxy " + inputLine);
			waitingForMouse = true;
			while(waitingForMouse) {
				Thread.sleep(50);
				// wait for mouse press
			}
			gal2x = imageHolder.mouseX;
			gal2y = imageHolder.mouseY;
			System.out.println(gal2x + "  " + gal2y);

	/**********************************/

			pparcsecX = ((double)(gal2x-gal1x)/(double)(gal2.skyPoint.x-gal1.skyPoint.x));
			pparcsecY = ((double)(gal2y-gal1y)/(double)(gal2.skyPoint.y-gal1.skyPoint.y));

			System.out.println("ppasx,ppasy:  " + pparcsecX + "   " + pparcsecY);

			xCenter = (int)(gal1x - gal1.skyPoint.x * pparcsecX);
			yCenter = (int)(imageHolder.getSize().height - (gal1y - gal1.skyPoint.y *pparcsecY));

			System.out.println("XCenter, YCenter " + xCenter + "  " + yCenter);

	/***********************************/



			System.out.println("OK, using that data puts the center at " + xCenter + " " + yCenter);

			imageHolder.repaint();
			repaint();


		} catch (Exception e) {
			System.out.println(e);
		}


	}

	public void setLocations() {
		double xhold;
		double yhold;

		Galaxy tempGal;
		for(int i=0; i< gals.size(); i++) {
			tempGal = (Galaxy)gals.elementAt(i);

			xhold=tempGal.skyPoint.x*Math.cos(anglerad) +
				     tempGal.skyPoint.y*Math.sin(anglerad);

			yhold=-tempGal.skyPoint.x*Math.sin(anglerad) +
				     tempGal.skyPoint.y*Math.cos(anglerad);

			tempGal.x = (int)(xCenter + xhold*pparcsecX);
			tempGal.y = (int)(imageHolder.getSize().height - (yCenter - yhold*pparcsecY));
			gals.setElementAt(tempGal,i);
		}
	}

	public void writeFile() {
		try {
			System.out.println("Writing to output file");
			writer = new PrintWriter(new FileWriter(outputFile), true);
			writer.println("! " + imageWidth + " ! " + imageHeight );
			writer.println("#number  |  name  |    X    |    Y    |  mag  |  vel  |   rad");
			Galaxy tempGal;
			for(int i=0; i< gals.size(); i++) {
				tempGal = (Galaxy)gals.elementAt(i);
				if((!tempGal.isChecked()) && ((tempGal.x > 0)&&(tempGal.x < imageWidth)) && ((tempGal.y > 0)&&(tempGal.y < imageHeight))) {
					writer.println(tempGal.number + "  |  " + tempGal.name + "  |  " + tempGal.x + "  |  " + tempGal.y + "  |  " + tempGal.mag + "  |  " + tempGal.vel + "  |  " + FMath.rss(tempGal.skyPoint.x,tempGal.skyPoint.y) );
				}
			}
			System.out.println("Done");
		} catch (IOException e) {
			System.out.println("Caught IOException in writeFile");
			System.out.println(e);
		}
	}

	class ImageHolder extends Canvas {

		int mouseX, mouseY;
		Galaxy tempGal, dragGal;

		Image image;

		public void paint(Graphics g) {
			g.drawImage(image,0,0,this);
			g.setColor(Color.yellow);
			g.drawString(mouseX + " , " + mouseY,15,15);

			g.setColor(Color.white);
			g.drawLine(xCenter-5,yCenter,xCenter+5,yCenter);
			g.drawLine(xCenter,yCenter-5,xCenter,yCenter+5);

			g.setColor(Color.green);

			for(int i=0; i< gals.size(); i++) {
				tempGal = (Galaxy)gals.elementAt(i);
				if(tempGal.isChecked()) {
					g.drawLine(tempGal.x-5,tempGal.y-5,tempGal.x+5,tempGal.y+5);
					g.drawLine(tempGal.x-5,tempGal.y+5,tempGal.x+5,tempGal.y-5);
				} else {
					g.drawOval(tempGal.x-5,tempGal.y-5,10,10);
				}
			}
		}



		public ImageHolder(String imageName) {
			//System.out.println(image.getWidth(this) + "  " +image.getHeight(this));


			System.out.println(imageName);
			image = Toolkit.getDefaultToolkit().getImage(imageName);
			setSize(image.getWidth(this),image.getHeight(this));



			addMouseListener(new MouseAdapter() {
				public void mousePressed(MouseEvent e) {
					mouseX = e.getX();
					mouseY = e.getY();
					dragGal = null;
					for(int i=0; i< gals.size(); i++) {
						tempGal = (Galaxy)(gals.elementAt(i));
						if(FMath.rss((mouseX-tempGal.x),(mouseY-tempGal.y)) <= 5) {
							System.out.println("Closest galaxy is " + (i+1));
							dragGal = tempGal;
							break;
						}
					}
					waitingForMouse = false;
				}
				public void mouseReleased(MouseEvent e) {
					mouseX = e.getX();
					mouseY = e.getY();
					dragGal = null;
					waitingForMouse = false;
				}
				public void mouseClicked(MouseEvent e) {
					mouseX = e.getX();
					mouseY = e.getY();
					for(int i=0; i< gals.size(); i++) {
						tempGal = (Galaxy)(gals.elementAt(i));
						if(FMath.rss((mouseX-tempGal.x),(mouseY-tempGal.y)) <= 5) {
							tempGal.checked = !tempGal.isChecked();
							repaint(tempGal.x-7,tempGal.y-7,14,14);
							break;
						}
					}
				}
			});

			addMouseMotionListener(new MouseMotionAdapter() {
				public void mouseDragged(MouseEvent e) {
					if(dragGal != null) {
						dragGal.x = e.getX();
						dragGal.y = e.getY();
						for(int i=0; i< gals.size(); i++) {
							tempGal = (Galaxy)(gals.elementAt(i));
							if(dragGal.number.equals(tempGal.number)) {
								gals.setElementAt(dragGal,i);
								break;
							}
						}
						repaint(Math.min(dragGal.x,mouseX)-30,Math.min(dragGal.y,mouseY)-30,60,60);
						mouseX = e.getX();
						mouseY = e.getY();
					}
				}
				public void mouseMoved(MouseEvent e) {
					mouseX = e.getX();
					mouseY = e.getY();
					repaint(0,0,75,25);
				}
			});

			addKeyListener(new KeyAdapter() {
				public void keyPressed(KeyEvent e) {
					//System.out.println(e);
					double multiplier=1;
					boolean update = true;
					if(e.getKeyChar()=='.') {
						if(e.isControlDown()) multiplier = 10;
						angle+=.01 * multiplier;
						anglerad=angle*Math.PI/180;
						System.out.println("angle: " + angle);
					}
					else if(e.getKeyChar()==',') {
						if(e.isControlDown()) multiplier = 10;
						angle-=.01 * multiplier;
						anglerad=angle*Math.PI/180;
						System.out.println("angle: " + angle);
					}
					else if(e.getKeyChar()=='x') {
						if(e.isControlDown()) multiplier = 10;
						pparcsecX+=.001*pparcsecX * multiplier;
						System.out.println("pparcsecX: " + pparcsecX);
					}
					else if(e.getKeyChar()=='z') {
						if(e.isControlDown()) multiplier = 10;
						pparcsecX-=.001*pparcsecX * multiplier;
						System.out.println("pparcsecX: " + pparcsecX);
					}

					else if(e.getKeyChar()=='s') {
						if(e.isControlDown()) multiplier = 10;
						pparcsecY+=.001*pparcsecY * multiplier;
						System.out.println("pparcsecY: " + pparcsecY);
					}
					else if(e.getKeyChar()=='a') {
						if(e.isControlDown()) multiplier = 10;
						pparcsecY-=.001*pparcsecY * multiplier;
						System.out.println("pparcsecY: " + pparcsecY);
					}

					else if(e.getKeyChar()=='2') {
						if(e.isControlDown()) multiplier = 10;
						xCenter +=1 * multiplier;
						System.out.println("xCenter: " + xCenter);
					}
					else if(e.getKeyChar()=='1') {
						if(e.isControlDown()) multiplier = 10;
						xCenter -=1 * multiplier;
						System.out.println("xCenter: " + xCenter);
					}

					else if(e.getKeyChar()=='5') {
						if(e.isControlDown()) multiplier = 10;
						yCenter +=1 * multiplier;
						System.out.println("yCenter: " + yCenter);
					}
					else if(e.getKeyChar()=='4') {
						if(e.isControlDown()) multiplier = 10;
						yCenter -=1 * multiplier;
						System.out.println("yCenter: " + yCenter);
					}
					else if(e.getKeyChar()=='w') {
						writeFile();
					}
					else if(e.getKeyChar()=='?') {
						System.out.println("Commands: ");
						System.out.println(", - Decrease Rotation     . - Increase Rotation");
						System.out.println("z - Decrease XStretch     x - Increase XStretch");
						System.out.println("a - Decrease YStretch     s - Increase YStretch");
						System.out.println("1 - Decrease XCenter      2 - Increase XCenter");
						System.out.println("4 - Decrease YCenter      5 - Increase YCenter");
						System.out.println("Holding down control will set increment to 10x its normal value");
						System.out.println("w - Write current positions to output file");
					}
					else {
						update = false;
					}
					if(update == true) {
						setLocations();
						imageHolder.repaint();
					}
				}
			});
		}
	}
}
